"use strict";

/* 日程表的相关逻辑 */

var agendaFunc = {
  // 处理calendar的select事件
  handleSelect: function handleSelect(start, end, jsEvent, view) {
    var startDate = moment(start).format('YYYY-MM-DD HH:mm');
    var endDate = moment(end).format('YYYY-MM-DD HH:mm');

    if (isMonthView(agenda)) {
      agenda.fullCalendar('gotoDate', start);
    }

    callPC('changePcDate', startDate);
  },
  // 处理calendar的eventRender事件
  handleEventRender: function handleEventRender(event, $el) {
    var isMeeting = event.ismeeting;
    agendaFunc.renderEventTypeIcon(isMeeting, $el);
    agendaFunc.bindDblclickEventSource(event, $el);
  },
  // 处理calendar的eventClick事件
  handleEventClick: function handleEventClick() { },
  // 根据eventSource的类型渲染不同图标
  renderEventTypeIcon: function renderEventTypeIcon(isMeeting, $el) {
    var timeEle = $el.find('.fc-time');

    if (isMeeting) {
      var icon = '<div class="event-icon meeting-icon"></div>';
      if (timeEle.length) {
        timeEle.prepend(icon);
      } else $el.find('.fc-content').prepend(icon);
    } else {
      var icon = '<div class="event-icon schedule-icon"></div>';
      if (timeEle.length) {
        timeEle.prepend(icon);
      } else $el.find('.fc-content').prepend(icon);
    }
  },
  // 为eventSource绑定双击事件
  bindDblclickEventSource: function bindDblclickEventSource(eventSource, $el) {
    $el.bind('dblclick', function () {
      var payload = {
        id: eventSource.id,
        accountId: eventSource.accountid
      };
      callPC('clickCalendar', payload);
    });
  }
};