'use strict';

// 声明全局变量
var fc = {};
var rooms = [];
var layer = {};
var layers = {};
var supportUtc = false; // 服务器是否支持tz=UTC

$(function () {
  layui.use('layer', function () {
    layer = layui.layer;
    layers = layui.layer;
  });
  fc = $('#calendar'); // 初始化日程组件

  fc.fullCalendar({
    selectable: true,
    slotLabelInterval: '1:00',
    slotLabelFormat: 'H:00',
    timeFormat: 'H:mm',
    selectHelper: true,
    selectOverlap: false,
    //事件在是否可重叠时间，默认false
    // height:650,
    contentHeight: 622,
    // selectConstraint: '1' ,
    // selectAllow: function({start:nowDate,end:nowDate}),
    selectMinDistance: 0,
    //设置选择生效的光标最小移动距离，非零值可区分单击和拖选
    scrollTime: '8:00:00',
    // 使滚动条最初位置处于能显示设置的时间处
    // editable: true, // enable draggable events
    // aspectRatio: 1.8,
    select: function select(startDate, endDate, jsEvent, view, resource) {
      var meetingRoomInfo = '';
      var isOrNotAllDay = false;
      if (!startDate.hasTime() && !endDate.hasTime()) isOrNotAllDay = true;
      var start = startDate.format('YYYY-MM-DD HH:mm');
      var end = endDate.format('YYYY-MM-DD HH:mm');
      var meetingRoomId = resource.id;
      if (meetingRoomId.match('notNeedMeetingRoom') === null) meetingRoomInfo = "\"".concat(resource.title, "\"<").concat(meetingRoomId, ">");
      if (endDate.format('H:mm').match(/^0:00/) !== null) end = endDate.subtract(1, 'd').format('YYYY-MM-DD') + ' 23:59';
      var calData = {
        start: start,
        end: end,
        meetingRoomInfo: meetingRoomInfo,
        isOrNotAllDay: isOrNotAllDay
      };
      callPC('createMeeting', JSON.parse(JSON.stringify(calData)));
    },
    header: {
      left: 'today',
      center: 'prev title next',
      right: 'agendaDay,agendaThreeDays'
    },
    allDayText: '全天',
    titleFormat: 'YYYY.MM.DD',
    buttonText: {
      today: '今天: ' + moment().format('YYYY.MM.DD') + ' ' + week(moment()),
      agendaDay: '当前'
    },
    views: {
      agendaThreeDays: {
        type: 'agenda',
        duration: {
          days: 3
        },
        buttonText: '近三天'
      }
    },
    columnHeaderText: function columnHeaderText(day) {
      switch (day.weekday()) {
        case 1:
          return day.format('M.D/') + '周一 ';
          break;

        case 2:
          return day.format('M.D/') + '周二 ';
          break;

        case 3:
          return day.format('M.D/') + '周三';
          break;

        case 4:
          return day.format('M.D/') + '周四 ';
          break;

        case 5:
          return day.format('M.D/') + '周五 ';
          break;

        case 6:
          return day.format('M.D/') + '周六 ';
          break;

        case 0:
          return day.format('M.D/') + '周日 ';
          break;

        default:
          break;
      }
    },
    defaultView: 'agendaThreeDays',
    groupByResource: true,
    resources: rooms,
    eventRender: function eventRender(event, element) {
      if (event.className == 'ordered') {
        element.css({
          'background-color': '#ff814d',
          'border-color': '#ff814d'
        });
      }
    },
    eventClick: function eventClick(calEvent, jsEvent, view) {
      var eStart = calEvent.start.format('H:mm');
      var eEnd = ' - ' + calEvent.end.format('H:mm');

      if (eEnd.match('0:00') !== null && eStart.match('0:00') !== null) {
        if (calEvent.start.format('YYYY-MM-DD').match(calEvent.end.subtract(1, 'd').format('YYYY-MM-DD')) !== null) {
          eStart = calEvent.start.format('MM.DD ') + week(calEvent.start);
          eEnd = '';
        } else {
          eStart = calEvent.start.format('MM.DD ') + week(calEvent.start);
          eEnd = ' - ' + calEvent.end.format('MM.DD ') + week(calEvent.end);
        }
      }

      var cEvent = jsEvent.currentTarget;
      layer.open({
        type: 4,
        shade: 0,
        area: ['180px', '70px'],
        tips: 2,
        closeBtn: 0,
        content: ["<div id='dialog'><p></p><p></p></div>", cEvent],
        skin: 'meeting-click-tips',
        success: function success() {
          $('#dialog p:nth-child(1)').text(eStart + eEnd);
          $('#dialog p:nth-child(2)').text(calEvent.title);
          $(document).click(function (e) {
            if ($(e.target).closest('.fc-event').length > 0) return false;else {
              if (!$(e.target).closest(".layui-layer").length > 0) {
                layer.close(layer.index);
              }
            }
          });
          $('.fc-scroller').scroll(function () {
            layer.close(layer.index);
          });
        }
      });
    }
  });
  callPC('initMeetingRooms', '0');
  callPC('ready');
});