"use strict";

// window.CoreMail = function (order, data) { } //开发时开启
//   order：
//   initMeetingRooms 初始化会议室列表
//   createMeeting 新建会议
//   notDisplayGuideMov 不再显示新手指引
//   delegate：
//   initMeetingRooms_callBack(display, domain, coreMailSid, start, end)
// }

window.app = {
  guide: false,
  apiServer: '',
  sid: '',
  dn: '',
  initMeetingRooms_callBack: function initMeetingRooms_callBack(display, domain, orgId, coreMailSid, start, end) {
    if (display == 1) {
      newGuideControl();
    }
    setTimeout(function () {
      notHightLight();
      bindButtonClickEvent(); // 日期选择器
    });
    layui.use('laydate', function () {
      var laydate = layui.laydate;
      lay('.fc-center h2').on('click', function () {
        $('#alls').text(selectedDate());
        laydate.render({
          elem: '#alls',
          theme: '#aeaeae',
          show: true,
          closeStop: '.fc-center h2',
          showBottom: false,
          position: 'absolute',
          done: function done(value) {
            fc.fullCalendar('gotoDate', value);
            rooms.forEach(function (item) {
              return getEvent('cal:getUserFreeBusyStatus', {
                fromdate: selectedDate() + ' 0:00',
                m: true,
                todate: endDate() + ' 23:59',
                toweb: true,
                user_id: item.id
              }, item.id);
            });
          }
        });
      });
    });
  },
  addMeetingRooms_delegate: function addMeetingRooms_delegate(startTime, endTime) {
    setHightLight(startTime, endTime);
    bindButtonClickEvent(); // 重新设置日期选择器,限制可选日期范围

    layui.use('laydate', function () {
      var laydate = layui.laydate;
      lay('.fc-center h2').on('click', function () {
        $('#alls').text(selectedDate());
        laydate.render({
          elem: '#alls',
          theme: '#aeaeae',
          show: true,
          closeStop: '.fc-center h2',
          showBottom: false,
          position: 'absolute',
          min: startTime.split(' ')[0],
          max: endTime.split(' ')[0],
          done: function done(value) {
            fc.fullCalendar('gotoDate', value);
            rooms.forEach(function (item) {
              return getEvent('cal:getUserFreeBusyStatus', {
                fromdate: selectedDate() + ' 0:00',
                m: true,
                todate: endDate() + ' 23:59',
                toweb: true,
                user_id: item.id
              }, item.id);
            });
          }
        });
      });
    });
  },
  // 添加日程事件
  addFullCalendar: function addFullCalendar(sources) {
    for (var i = 0; i < sources.length; i++) {
      sources[i]['className'] = 'calendarActive';
    }

    agenda.fullCalendar('addEventSource', sources);
  },
  // 删除
  removeFulCalendar: function removeFulCalendar(event) {// agenda.fullCalendar('removeEventSources', event)
  },
  // 更新
  updateFullCalendar: function updateFullCalendar(event) {// agenda.fullCalendar('updateEvent', event)
  },
  // 设置日程表的当前日期
  setCalendarCurrentDate: function setCalendarCurrentDate(date) {
    var toDate = moment(date, 'YYYY-MM-DD');
    agenda.fullCalendar('gotoDate', toDate);
  },
  // 选中日程表的单元格
  selectCalendarCells: function selectCalendarCells(date) {
    var start = moment(date, 'YYYY-MM-DD');
    agenda.fullCalendar('gotodate', start);
    if (isMonthView(agenda)) {
      agenda.fullCalendar('select', start);
    }
  },
  // 重新渲染日程
  reRenderCalendar: function reRenderCalendar(sources) {
    for (var i = 0; i < sources.length; i++) {
      sources[i]['className'] = 'calendarActive';
    }

    agenda.fullCalendar('removeEvents');
    agenda.fullCalendar('addEventSource', sources);
  },
  // 获取所有的会议室
  getAllMeeting: function getAllMeeting(data) {
    var roomsList = data;
    $('.list-content ul').append($('<li>').text('无需会议室'));
    var notNeedRoom = $('.list-content ul li:first');
    notNeedRoom.addClass('list-active');
    rooms.push({
      id: 'notNeedMeetingRoom',
      title: '无需会议室'
    });
    fc.fullCalendar('refetchResources'); //会议室为空

    if (roomsList.length === 0) {
      notNeedRoom.click(function () {
        if (!$(this).hasClass('list-active')) {
          $(this).addClass('list-active');
          rooms.push({
            id: 'notNeedMeetingRoom',
            title: '无需会议室'
          });
          fc.fullCalendar('refetchResources');
        } else {
          $(this).removeClass('list-active');
          var mid = rooms.findIndex(function (room) {
            return room.id === 'notNeedMeetingRoom';
          });
          rooms.splice(mid, 1);
          fc.fullCalendar('refetchResources');
        }
      });
    } else {
      //会议室不为空
      $('.chose-all').show();
      notNeedRoom.on('click', function () {
        // 切换激活类名
        if (!$(this).hasClass('list-active')) {
          $('.list-content ul li').removeClass('list-active');
          $(this).addClass('list-active');
          rooms.splice(0, rooms.length);
          rooms.push({
            id: 'notNeedMeetingRoom',
            title: '无需会议室'
          });
          $('#checked').hide();
          fc.fullCalendar('refetchResources');
        } else {
          $(this).removeClass('list-active');
          var mid = rooms.findIndex(function (room) {
            return room.id === 'notNeedMeetingRoom';
          });
          rooms.splice(mid, 1);
          fc.fullCalendar('refetchResources');
        }
      });

      var _iterator = _createForOfIteratorHelper(roomsList),
        _step;

      try {
        var _loop = function _loop() {
          var item = _step.value;
          $('.list-content ul').append($('<li>').text(item.true_name));
          el = $('.list-content ul li:last');
          // 会议室hover提示
          el.mouseenter(function () {
            var that = $(this);
            layers.tips(item.true_name, that, {
              tips: 2,
              tipsMore: true,
              time: 0,
              anim: 5,
              skin: 'room-hover-tips'
            });
          });
          el.mouseleave(function () {
            layers.close(layers.index);
          });
          $('.list-content ul').click(function () {
            layer.closeAll('tips');
          });
          // 会议室click事件
          $('.list-content ul li:last').on('click', function () {
            if (!$(this).hasClass('list-active')) {
              $(this).addClass('list-active');
              if (notNeedRoom.hasClass('list-active')) {
                notNeedRoom.removeClass('list-active');
                var mid = rooms.findIndex(function (room) {
                  return room.id === 'notNeedMeetingRoom';
                });
                rooms.splice(mid, 1);
              }
              rooms.push({
                id: item.email,
                title: item.true_name
              });
              fc.fullCalendar('refetchResources');
              getEvent('cal:getUserFreeBusyStatus', {
                fromdate: selectedDate() + ' 0:00',
                m: true,
                todate: endDate() + ' 23:59',
                toweb: true,
                user_id: item.email
              }, item.email);
            } else {
              if ($('#checked').css('display').match(/[none]/)) $('#checked').hide();
              $(this).removeClass('list-active');
              var mid = rooms.findIndex(function (room) {
                return room.id === item.email;
              });
              rooms.splice(mid, 1);
              fc.fullCalendar('refetchResources');
            }
          });
        };

        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var el;

          _loop();
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }

    $('.chose').click(function () {
      // 全选按钮请求全部数据
      $('#checked').show();
      $('.chose-all span').css('color', '#212121');
      $('.list-content ul li:not(:first)').addClass('list-active');
      if (notNeedRoom.hasClass('list-active')) notNeedRoom.removeClass('list-active');
      rooms.splice(0, rooms.length);
      roomsList.forEach(function (item) {
        rooms.push({
          id: item.email,
          title: item.true_name
        });
      });
      fc.fullCalendar('refetchResources');
      rooms.forEach(function (item) {
        return getEvent('cal:getUserFreeBusyStatus', {
          fromdate: selectedDate() + ' 0:00',
          m: true,
          todate: endDate() + ' 23:59',
          toweb: true,
          user_id: item.id
        }, item.id);
      });
    });
    $('#checked').click(function () {
      //取消全选
      $('#checked').hide();
      $('.chose-all span').css('color', '#666666');
      $('.list-content ul li').removeClass('list-active');
      rooms.splice(0, rooms.length);
      fc.fullCalendar('refetchResources');
    });
  },
  // 获取对应会议室的使用情况
  getDetailAboutEvent: function getDetailAboutEvent(data, resId) {
    var booked = [];
    var res = data;
    res.forEach(function (item) {
      booked.push({
        id: resId.concat(item[0]),
        resourceId: resId,
        start: item[0],
        end: item[1],
        title: item[2].split(/\"\s*/)[1] ? item[2].split(/\"\s*/)[1] : item[2],
        className: 'ordered'
      });
    });
    if (booked.length !== 0) {
      booked.forEach(function (item) {
        var cEvents = fc.fullCalendar('clientEvents', item.id);
        if (cEvents.length === 0) fc.fullCalendar('renderEvent', item, true);
      });
    }
  }
};