"use strict";

var callPC = function callPC() {
  var funcName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var strArgs = JSON.stringify(args);
  window.location.assign("coremail://" + funcName + "?" + strArgs);
  console.log('callPC-->', funcName, strArgs);
};

function saveSelection() {
  if (window.getSelection) {
      var sel = window.getSelection();
      if (sel.getRangeAt && sel.rangeCount) {
          return sel.getRangeAt(0);
      }
  } else if (document.selection && document.selection.createRange) {
      return document.selection.createRange();
  }
  return null;
}
function restoreSelection(range) {
  if (range) {
      if (window.getSelection) {
          var sel = window.getSelection();
          sel.removeAllRanges();
          sel.addRange(range);
      } else if (document.selection && range.select) {
          range.select();
      }
  }
}

$(document).ready(function ($) {
  window.app = {

    gSelect1 : null,
    gSelect2 : null,
    globalLoadSelection : function () {
      $('body').blur();
      if (app.gSelect1 == null)
        restoreSelection(app.gSelect2);
      else
        restoreSelection(app.gSelect1);
    },
    globalSaveSelection: function() {
      app.gSelect2 = app.gSelect1;
      app.gSelect1 = saveSelection();
    },
    zhtran : function(zh_choose) {
      zh_tran(zh_choose);
    },
    resizeTable: function resizeTable() {
      var oldNum = 0;
      var tnum = $('table').length;

      for (var i = oldNum; i < tnum; i++) {
        //var num = Math.floor(Math.random() * 1000000);
        //var res = 'cmx-size-grip' + num;
        //$('table').eq(i - 1).append('<div class= ' + res + ' style="position: absolute; width: 16px; height: 16px; bottom: 2px; right: 0; cursor: nwse-resize; background: url(wingrip.png) no-repeat;"></div>')
        $('table').eq(i - 1).append('<div class="cim-resizable-icon"></div>');
        $('table').eq(i - 1).resizable({
          handleSelector: "> .cim-resizable-icon"
        });
      }

      oldNum = tnum;
    },
    loadImage: function loadImage(imageId) {
      var bodyWidth = $('body').width();
      var naturalWidth = $("#${imageId}")[0].naturalWidth;
      var naturalHeight = $("#${imageId}")[0].naturalHeight;

      if (naturalWidth > bodyWidth) {
        var initWidth = parseInt(bodyWidth);
        var naturalRate = naturalWidth / naturalHeight;
        var initHeight = parseInt(initWidth / naturalRate);
        $("#${imageId}").attr("data-width", initWidth).attr("data-height", initHeight);
        $("#${imageId}").width(initWidth).height(initHeight);
      }
    },
    resizeImage: function resizeImage() {
      //当图片宽度大于body的宽度时设置图片自适应宽高，并用自定义属性保存
      var imageArray = document.images;

      for (var i = 0; i < imageArray.length; i++) {
        var image = imageArray[i];

        if (!$(image).attr('data-width') && !$(image).attr('data-height')) {
          var defaultWidth = image.naturalWidth;
          var defaultHeight = image.naturalHeight;
          var bodyWidth = $('body').width();
          console.log(defaultWidth);

          if (defaultWidth > bodyWidth) {
            var initWidth = parseInt(bodyWidth);
            var naturalRate = defaultWidth / defaultHeight;
            var initHeight = parseInt(initWidth / naturalRate);
            $(image).attr("data-width", initWidth).attr("data-height", initHeight);
            $(image).width(initWidth).height(initHeight);
          }
        }
      }
    },
    resizeImage2: function resizeImage2() {
      var oldNum = 0;
      var tnum = $('img').length;

      for (var i = 0; i < tnum; i++) {
        var image = $('img').eq(i);
        var width = $('img').eq(i).width();
        var height = $('img').eq(i).height();
        var hasParentResize = $('img').eq(i).parent().hasClass("cim_resizable_image_div");

        if (!hasParentResize) {
          // // reisze it
          var parentdiv = "<div class='cim_resizable_image_div' style='width:" + width + "px;height:" + height + "px; min-width: 1px; min-height: 1px'></div>";
          $('img').eq(i).wrap(parentdiv);
        }

        var hasResize = $('img').eq(i).next().hasClass("cim-resizable-icon");

        if (!hasResize) {
          //reisze it
          var cursortext = '<div class="cim-resizable-icon"></div>';
          $(cursortext).insertAfter($('img').eq(i));
        }

        $('img').eq(i).css({
          'height': '100%',
          'width': '100%'
        });
      }

      $(".cim_resizable_image_div").resizable({
        handleSelector: "> .cim-resizable-icon"
      });
    },
    initAutoImgResize: function initAutoImgResize(dom) {
      if (!dom) dom = $('body');else dom = $(dom);
      var image = null;
      $(document).on("keydown", function () {
        if (!image) return;
        image = null;
        $(".cim_resizable_image_div").remove();
        $(".cim-fullscreen").remove();
      });
      $(document).on("click", ".cim-fullscreen", function () {
        image = null;
        $(".cim_resizable_image_div").remove();
        $(".cim-fullscreen").remove();
      });
      $(document).on("click", ".cim_resizable_image_div", function () {
        $('body').blur();
      }); // 给img 的父div绑定鼠标移出事件，移出使按钮div消失

      $(document).on("mouseleave", '.cim_resizable_image_div', function (ev) {
        if (ev.which === 0) {
          $(".cim_resizable_image_div").remove();
          $(".cim-fullscreen").remove();
        }
      }); // 給img 绑定鼠标移入事件

      $(dom).delegate('img', 'mouseenter', function (ev) {
        setTimeout(function () {
          ev.stopPropagation();
          if ($(".cim_resizable_image_div").length) return;
          image = ev.target;
          var top = $(image).offset().top;
          var left = $(image).offset().left;
          var width = $(image).width();
          var height = $(image).height();
          var parentdiv = "<div class='cim_resizable_image_div' style='width:" + width + "px;height:" + height + "px; top:" + top + "px; left:" + left + "px;position: absolute; z-index: 1000;'><div class='btn' contenteditable='false' style='background:#f7f8fb;position:absolute;top:5px;left:5px;'><ul><li class='enlarge'></li><li class='shrink'></li><li class='default'></li><li class='delete'></li></ul></div><span class='drag-bottom'></span><span class='drag-right'></span><span class='drag-cross'></span></div>";
          $('body').append("<div class='cim-fullscreen'></div>" + parentdiv);
          /**
           * 给四个button绑定单击事件
           */

          $('.cim_resizable_image_div').find('ul .enlarge').click(function (ev) {
            var width = $(image).width();
            var height = $(image).height();
            $(image).width(width * 1.2);
            $(image).height(height * 1.2);
            var currentTop = $(image).offset().top;
            var currentLeft = $(image).offset().left;
            $(".cim_resizable_image_div").css('top', currentTop).css('left', currentLeft);
            $('.cim_resizable_image_div').width(width * 1.2);
            $('.cim_resizable_image_div').height(height * 1.2);
          });
          $('.cim_resizable_image_div').find('ul .shrink').click(function (ev) {
            var width = $(image).width();
            var height = $(image).height();
            $(image).width(width * 0.8);
            $(image).height(height * 0.8);
            var currentTop = $(image).offset().top;
            var currentLeft = $(image).offset().left;
            $(".cim_resizable_image_div").css('top', currentTop).css('left', currentLeft);
            $('.cim_resizable_image_div').width(width * 0.8);
            $('.cim_resizable_image_div').height(height * 0.8);
          });
          $('.cim_resizable_image_div').find('ul .default').click(function (ev) {
            var defaultWidth = image.naturalWidth;
            var defaultHeight = image.naturalHeight;

            if ($(image).attr('data-width') && $(image).attr('data-height')) {
              defaultWidth = +$(image).attr('data-width');
              defaultHeight = +$(image).attr('data-height');
            }

            $(image).width(defaultWidth);
            $(image).height(defaultHeight);
            var currentTop = $(image).offset().top;
            var currentLeft = $(image).offset().left;
            $(".cim_resizable_image_div").css('top', currentTop).css('left', currentLeft);
            $('.cim_resizable_image_div').width(defaultWidth);
            $('.cim_resizable_image_div').height(defaultHeight);
          }); // 获取当前光标位置

          var selection = window.getSelection();
          var startEv = ev; // ev 查找当前currentTarget

          var lastEditRange; // 拿光标

          if (selection.rangeCount > 0) {
            lastEditRange = selection.getRangeAt(0);
          } else {
            lastEditRange = document.createRange();
          } // 当点击图片后，光标位置移动到图片后


          $('.cim_resizable_image_div').on('click', function () {
            selection.removeAllRanges();
            lastEditRange.setStartAfter(startEv.currentTarget);
            lastEditRange.setEndAfter(startEv.currentTarget);
            selection.addRange(lastEditRange);
          });
          $('.cim_resizable_image_div').find('ul .delete').click(function (ev) {
            ev.stopPropagation(); // 光标位置移动到图片的位置

            selection.removeAllRanges();
            lastEditRange.setStartBefore(startEv.currentTarget);
            lastEditRange.setEndBefore(startEv.currentTarget);
            selection.addRange(lastEditRange);
            $(image).remove();
            $(".cim_resizable_image_div").remove();
            $(".cim-fullscreen").remove();
          });
          /**
           *实现三个拖放按钮的拖放事件
           */

          $(".cim_resizable_image_div").resizable({
            handleSelector: "> .drag-right",
            resizeHeight: false,
            onDrag: function onDrag(e, $el, newWidth, newHeight, opt) {
              var currentHeight = $(image).height();
              var currentTop = $(image).offset().top;
              var currentLeft = $(image).offset().left;
              $(image).width(newWidth);
              $(image).height(currentHeight);
              $(".cim_resizable_image_div").height(currentHeight);
              $(".cim_resizable_image_div").css('top', currentTop).css('left', currentLeft); //  dispatch input event , to change status

              var event = new Event('input', {
                bubbles: true
              });
              document.dispatchEvent(event);
              return true;
            }
          });
          $(".cim_resizable_image_div").resizable({
            handleSelector: "> .drag-bottom",
            resizeWidth: false,
            onDrag: function onDrag(e, $el, newWidth, newHeight, opt) {
              var currentWidth = $(image).width();
              $(image).width(currentWidth);
              $(image).height(newHeight);
              var currentTop = $(image).offset().top;
              var currentLeft = $(image).offset().left;
              $(".cim_resizable_image_div").height(currentWidth);
              $(".cim_resizable_image_div").css('top', currentTop).css('left', currentLeft); //  dispatch input event , to change status

              var event = new Event('input', {
                bubbles: true
              });
              document.dispatchEvent(event);
              return true;
            }
          });
          $(".cim_resizable_image_div").resizable({
            handleSelector: "> .drag-cross",
            resizeHeight: false,
            onDrag: function onDrag(e, $el, newWidth, newHeight, opt) {
              var currentWidth = $(image).width();
              var currentHeight = $(image).height();
              var currentTop = $(image).offset().top;
              var currentLeft = $(image).offset().left;
              var rate = currentWidth / currentHeight;
              $(image).width(newWidth);
              $(image).height(newWidth / rate);
              $(".cim_resizable_image_div").height(newWidth / rate);
              $(".cim_resizable_image_div").css('top', currentTop).css('left', currentLeft); //  dispatch input event , to change status

              var event = new Event('input', {
                bubbles: true
              });
              document.dispatchEvent(event);
              return true;
            }
          });
          $('body').blur();
        }, 120);
      });
    },
    removeAutoImgResize: function removeAutoImgResize() {
      // remove the parent image div first , for that the  old version's app use this logic to drag image
      var tnum = $('img').length;

      for (var i = 0; i < tnum; i++) {
        var image = $('img').eq(i);
        var hasParentResize = $('img').eq(i).parent().hasClass("cim_resizable_image_div");

        if (hasParentResize) {
          var width = $('img').eq(i).parent().width();
          var height = $('img').eq(i).parent().height();
          $('img').eq(i).unwrap();

          if (width != 0 && height != 0) {
            $('img').eq(i).css({
              'height': height,
              'width': width
            });
          }
        }
      }

      $(".cim_resizable_image_div").remove();
      $(".cim-fullscreen").remove();
      $(".cim-resizable-icon").remove();
    },
    expURL: /((https?|ftp|file):\/\/|www\.)[-A-Z0-9+&@#\/%?=~_|!:,.;]+[^\s,，。！…？：<>]*/gi,
    expEmail: /(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])/,
    initAutoURL: function initAutoURL(dom) {
      if (!dom) dom = $('body');else dom = $(dom);
      var curLink = null;
      $(dom).delegate('a', 'click', function (ev) {
        var mEvent = ev.originalEvent;

        if (mEvent.button == 0) {
          //altKey shiftKey ctrlKey
          if (mEvent.ctrlKey) {
            var url = $(ev.target).closest('a').attr('href');
            callPC("openURL", url);
            ev.stopPropagation();
            ev.preventDefault();
          }
        }
      }).delegate('a', 'mouseenter', function (ev) {
        curLink = ev.target;
      }).delegate('a', 'mouseleave', function (ev) {
        $(ev.target).removeClass('cursor_hand');
        curLink = null;
      });
      dom.bind('keyup', function (ev) {
        try {
          var keyCode = ev.keyCode;

          if (keyCode == 17) {
            if (curLink) {
              $(curLink).removeClass('cursor_hand');
            }
          }
        } catch (e) {}
      }).bind('keydown', function (ev) {
        try {
          var keyCode = ev.keyCode;

          var encodeText = function encodeText(text) {
            text = text.replace(/</g, '&lt;');
            text = text.replace(/>/g, '&gt;');
            return text;
          };

          var InsertURL = function InsertURL(src, url, ext, bAtLast) {
            var p = src.indexOf(url);
            var text1 = src.substr(0, p);
            var text2 = src.substr(p + url.length);
            var encode_url = url.indexOf("www.") == 0 ? "http://" + url : url;
            var link = encodeText(text1) + '<a href="' + ext + encode_url + '">' + url + '</a>&nbsp;' + encodeText(text2);
            document.execCommand('inserthtml', null, link);
          };

          if (keyCode != 27) {
            window.app.modified = true;
          }

          switch (keyCode) {
            case 17:
              {
                if (curLink) {
                  if (!$(curLink).hasClass('cursor_hand')) {
                    $(curLink).addClass('cursor_hand');
                  }
                }

                break;
              }

            case 13:
            case 32:
              {
                var selObj = window.getSelection();
                var anchorNode = selObj.anchorNode;

                if (anchorNode.nodeType == 3) {
                  var pNode = anchorNode.parentNode;
                  var bATag = pNode && pNode.tagName === 'A';

                  if (!bATag) {
                    var text = anchorNode.nodeValue;
                    var bAtLast = selObj.anchorOffset == text.length;
                    var test_text = text.substr(0, selObj.anchorOffset);
                    var ext_text = "";
                    var bFlag = false;
                    var ary = test_text.match(window.app.expURL);

                    if (!ary) {
                      ary = test_text.match(window.app.expEmail);
                      if (ary) ext_text = "mailto:";
                    }

                    if (ary) {
                      if (!bAtLast) {
                        $(anchorNode.parentNode).text(text.substr(selObj.anchorOffset));
                      }

                      InsertURL(test_text, ary[0], ext_text, bAtLast);
                      $(anchorNode).remove();

                      if (!bAtLast) {
                        var newNode = selObj.anchorNode;
                        var range = document.createRange();
                        range.setStartAfter(newNode, 0);
                        selObj.removeAllRanges();
                        selObj.addRange(range);
                      }

                      bFlag = true;
                    }

                    if (bFlag && keyCode == 32) {
                      ev.stopPropagation();
                      ev.preventDefault();
                    }
                  } else {
                    //Is A Tag
                    var text = anchorNode.nodeValue;
                    var ary = text.match(window.app.expURL);
                    if (!ary) ary = text.match(window.app.expEmail);

                    if (ary) {
                      $(pNode).attr("href", ary[0]);
                    }
                  }
                }

                break;
              }

            default:
              break;
          }
        } catch (e) {}
      });
    },
    applyInlineStyle: function applyInlineStyle(html, removeClassList) {
      var result = html;
      var bodyCssText = '';

      try {
        if (removeClassList == null) removeClassList = [];
        var dom = $('<div></div>').html(html);
        dom.find('style').each(function () {
          var style = $(this);
          $(document.body).prepend(style);
          var sheet = style[0].sheet;
          var rules = sheet.rules;

          for (var i = 0; i < rules.length; i++) {
            var item = rules[i];

            if (Object.prototype.toString.call(item) === '[object CSSStyleRule]') {
              var selectorText = item.selectorText;
              var nodes = dom.find(selectorText);

              if (nodes.length > 0 || selectorText === 'body') {
                if (item.style == null) continue;

                for (var k = 0; k < item.style.length; k++) {
                  var cssText = item.style[k];
                  var value = item.style[cssText];

                  if (selectorText === 'body') {
                    if (value !== '') {
                      bodyCssText = bodyCssText + cssText + ':' + value + ';';
                    }
                  } else nodes.css(cssText, value);
                }
              }
            }
          }

          style.remove();
        });
        dom.find('meta').remove();
        dom.find('link').remove();
        dom.find('head').remove();

        for (var i = 0; i < removeClassList.length; i++) {
          var className = removeClassList[i];
          dom.find('.' + className).removeClass(className);
        }

        result = dom.html();
      } catch (e) {}

      return {
        html: result,
        bodyCss: bodyCssText
      };
    },
    removeWaterMark: function removeWaterMark() {
      localStorage.removeItem('waterMarkStr');
      var waterMark = document.querySelector('.watermark-wrap-write');
      waterMark && waterMark.parentNode.removeChild(waterMark);

      if (waterMark) {
        for (var i = 0; i < waterMark.length; i++) {
          waterMark.parentNode.removeChild(waterMark[i]);
        }
      }
    } // 插入水印
    ,
    insertWaterMark: function insertWaterMark(str, win_width, win_height) {
      var lineStr = str.split('<br>');
      var date = '';
      var text = '';
      text = escape(lineStr[0]);

      if (lineStr[1]) {
        date = lineStr[1];
      }

      localStorage.setItem('waterMarkStr', str);
      var body = document.body;
      var cv = document.querySelector('.v-watermark');
      cv && cv.parentNode.removeChild(cv);
      var canvas = document.createElement('canvas');
      canvas.classList.add('v-watermark');
      var ctx = canvas.getContext('2d');
      var cvw = win_width ? win_width : window.innerWidth;
      var cvh = win_height ? win_height : window.innerHeight;
      canvas.width = cvw;
      canvas.height = cvh;
      var textLength = ctx.measureText(text).width;
      var intervalWidth = 234; // 每行的文字的宽度距离

      var customHeight = 180; // 每行的高度距离

      var angle = -12; // 度数

      var site = angle * Math.PI / 180;
      var secondTextlineHeight = 20; // 第二行文字的行高

      var rows = parseInt(canvas.height / customHeight);
      var colums = parseInt(canvas.width / (textLength + intervalWidth));
      ctx.save();
      ctx.font = '17px arial,sans-serif';
      ctx.textAlign = 'center';
      ctx.fillStyle = "#000000";
      ctx.globalAlpha = 0.2;
      ctx.rotate(site);

      for (var i = 1; i <= rows + 1; i++) {
        for (var j = 0; j <= colums; j++) {
          // 偶数行
          if (i % 2 === 0) {
            ctx.fillText(text, j * (textLength + intervalWidth) + textLength, i * customHeight);
            ctx.fillText(date, j * (textLength + intervalWidth) + textLength, i * customHeight + secondTextlineHeight);
          } else {
            ctx.fillText(text, j * (textLength + intervalWidth), i * customHeight);
            ctx.fillText(date, j * (textLength + intervalWidth), i * customHeight + secondTextlineHeight);
          }
        }
      }

      ctx.restore();
      var waterMark = document.querySelector('.watermark-wrap-write');
      waterMark && waterMark.parentNode.removeChild(waterMark);
      var base64 = canvas.toDataURL('image/png');
      var blob = dataURLtoBlob(base64);
      var Url = URL.createObjectURL(blob);
      var dom = document.createElement('div');
      dom.setAttribute('style', "background-image:url('".concat(Url, "')"));
      dom.classList.add('watermark-wrap-write');
      body.parentNode.appendChild(dom);
    },
    insertHTML: function insertHTML(html) {
      try {
        window.app.modified = true;
        html = window.app.applyInlineStyle(html, null).html;
        document.execCommand("InsertHtml", null, html);
      } catch (e) {}
    },
    changeFont: function changeFont(size) {
      var selObj = window.getSelection();

      if (selObj == '') {
        // 如果没有选中文本则插入一个宽度为0的span
        var text = '<span style=\'font-size:' + size + 'pt' + ' \'>&#8203;</span>';
        document.execCommand('inserthtml', null, text);
      } else {
        document.execCommand("fontSize", false, "7");
        $(document).find('[style*="font-size: -webkit-xxx-large"],font[size]').css("fontSize", size + "pt");
      }
    },
    adjustLineHeight: function adjustLineHeight(size) {
      document.execCommand('formatblock', false, 'p');
      var selectedNodes = [];
      var sel = window.getSelection();

      for (var i = 0; i < sel.rangeCount; i++) {
        selectedNodes = selectedNodes.concat(sel.getRangeAt(i).getNodes());
        $(selectedNodes).css("height", "" + size);
      }

      var selectedElement = window.getSelection().focusNode.parentNode;
      $(selectedElement).css("height", "" + size);
    },
    insertURLAndTitle: function insertURLAndTitle(linkURL, sText) {
      document.execCommand('insertHTML', false, '<a href="' + linkURL + '">' + sText + '</a>');
    },
	getHtmlSource: function getHtmlSource() {
		var res = "<head>" + document.getElementsByTagName('head')[0].innerHTML + "</head>" + document.body.outerHTML;
        callPC('getHtmlSrc', res);
	},
	getTextSource: function getTextSource() {
        var res = document.body.innerText;
        callPC('getTextSrc', res);
	},
	resetModified: function resetModified() {
		window.app.modified = false;
	}
  }; // loaded, clan resizable-icon, for tabel will remove the div before table tag
  //$('.cim-resizable-icon').remove();

  app.removeAutoImgResize();
  app.resizeTable(); //	setTimeout(app.resizeImage(), 1000);
  //	app.resizeImage();

  app.initAutoURL();
  app.initAutoImgResize();
  document.execCommand("enableInlineTableEditing", true, "");
  document.execCommand("enableObjectResizing", true, "");
  document.execCommand("styleWithCSS", false, "");

  document.onselectionchange = function () {
    
    //app.globalSaveSelection();

    var bselecttext = false;

    if (window.getSelection) {
      var selection = window.getSelection();
      var selstring = selection.toString();

      if (selstring) {
        bselecttext = true;
      }
    }

    var request = {
      'bold': document.queryCommandState('bold'),
      'italic': document.queryCommandState('italic'),
      'underline': document.queryCommandState('underline'),
      'strikeThrough': document.queryCommandState('strikeThrough'),
      'fontcolor': document.queryCommandValue('foreColor'),
      'backcolor': document.queryCommandValue('backColor'),
      'fontName': document.queryCommandValue('fontName') //sJScomand += "',\"' + 'fontsize' + '\":\"' + document.queryCommandValue('fontsize') +'\"' +"; //px转换成pt，四舍五入为整数
      ,
      'fontsize': parseFloat(window.getComputedStyle(window.getSelection().focusNode.parentElement).fontSize) * 72 / 96 + 0.5,
      'alignright': document.queryCommandState('justifyRight'),
      'aligncenter': document.queryCommandState('justifycenter'),
      'alignleft': document.queryCommandState('justifyLeft'),
      'orderedList': document.queryCommandState('insertOrderedList'),
      'UnorderedList': document.queryCommandState('insertUnorderedList'),
      'undo': document.queryCommandEnabled('undo'),
      'redo': document.queryCommandEnabled('redo'),
      'selectText': bselecttext,
      'Link': document.queryCommandValue('createLink'),
      'Modify': window.app.modified
      //,'text' : app.gSelect1.toString()
    };
    callPC("statusChanged", request);
  };

  jQuery(document).on('paste', function (e) {
    window.app.modified = true;
    e.preventDefault();
    callPC("doPaste");
  });
  jQuery(document).on('mouseup', function (e) {
    callPC("domouseup");
  });
  $(document).keydown(function(e) {
    if (e.key === "Escape") // escape key maps to keycode `27`
      callPC("esccompose");
    else if ((e.ctrlKey || e.metaKey) && (e.keyCode == 13 || e.keyCode == 10)) {
      e.preventDefault();
      e.stopPropagation();
      callPC("sendcompose");
    }
    else if (e.metaKey && e.keyCode == 86) {  //V
      window.app.modified = true;
      e.preventDefault();
      callPC("doPaste");
    }
    else if (e.metaKey && e.keyCode == 67) {  //C
      e.preventDefault();
      callPC("doCopy");
    }
    else if (e.metaKey && e.keyCode == 88) {  //X
      e.preventDefault();
      callPC("doCut");
    }
  });

  function escape(string) {
    string = string || '';
    return string.replace(/&nbsp;/g, ' ').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&apos;/g, '"').replace(/&quot;/g, "'").replace(/&amp;/g, '&').replace(/&#162;/g, '￠').replace(/&pound;/g, '£').replace(/&yen;/g, '¥').replace(/&euro;/g, '€').replace(/&divide;/g, '÷').replace(/&times;/g, '×').replace(/&#34;/g, '"').replace(/&#39;/g, "'");
  }

  function windowResized(e) {
    resizeCanvas();
  }

  function dataURLtoBlob(dataUrl) {
    var arr = dataUrl.split(','),
        mime = arr[0].match(/:(.*?);/)[1],
        bstr = atob(arr[1]),
        len = bstr.length,
        u8arr = new Uint8Array(len);

    while (len--) {
      u8arr[len] = bstr.charCodeAt(len);
    }

    return new Blob([u8arr], {
      type: mime
    });
  }

  function resizeCanvas() {
    var body = document.body;
    body.setAttribute('style', "\n            z-index:9999;\n            pointer-events:none;\n            background-repeat:repeat;\n            border-width:0px; \n            margin:12px; \n            line-height:1.3;\n        ");
    var waterMarkStr = localStorage.getItem('waterMarkStr');
    waterMarkStr && app.insertWaterMark(waterMarkStr);
  }

  callPC('ready');
});