"use strict";

 // c++调用js的接口
var api = {

  supportTheme : false,
  isDarkMode : false,

  // 是否显示加载中
  showLoadingCover: function showLoadingCover(status) {
    status.bShow ? asyncShowLoading() : asyncHideLoading();

    function asyncShowLoading() {
      setTimeout(function () {
        $('#loading-container').show();
      });
    }
    function asyncHideLoading() {
      setTimeout(function () {
        $('#loading-container').hide();
      });
    }
  },

  zhchange: function zhchange(zh_choose) {
    zh_tran(zh_choose);
    var param = {
      zhtrans: true,
      zh_choose: zh_choose
    };
    var iframes = document.getElementsByTagName('iframe');
    for (var i =0; i < iframes.length; ++i)
      iframes[i].contentWindow.postMessage(JSON.stringify(param), '*');    
  },

  setTheme : function setTheme()  {
    if (arguments[0] == "close") {
      if (api.supportTheme) {
        $('link[rel="stylesheet"]').attr('href','./static/css/base.css');
        api.supportTheme = false;
        api.isDarkMode = false;
      } else
        return;
    } else if (arguments[0] == "dark") {
      api.supportTheme = true;
      api.isDarkMode = true;
      $('link[rel="stylesheet"]').attr('href','./static/css/basedark.css');
    } else {
      api.supportTheme = true;
      api.isDarkMode = false;
      $('link[rel="stylesheet"]').attr('href','./static/css/base.css');
    }
    
    setTimeout(function() {
      var param = {
        setTheme: true,
        color : $('body').css("color")
      };
      var iframes = document.getElementsByTagName('iframe');
      for (var i =0; i < iframes.length; ++i)
        iframes[i].contentWindow.postMessage(JSON.stringify(param), '*');
    });
  },
  // 设置邮件信息
  setMailInfo: function setMailInfo() {
    var mails = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var decodeMailInfo = escape(mails.title);
    $('.mail-conversations .title').text(decodeMailInfo);
    mailRender.renderConversations(mails.mailInfo);
    ifShowWaterMark(mails);
    if (typeof Promise.resolve === 'function') {
      Promise.resolve(api.clearReadMailTemplate(false));
    } else {
      setTimeout(function () {
        api.clearReadMailTemplate(false);
      });
    }
  },
  // 更新邮件内容信息
  updateMailInfo: function updateMailInfo(info) {
    var mail = getMailByMailId(info.mailId);
    if (info.mailInfo['content']) {
      var url = escape(info.mailInfo['content']);
      if (api.supportTheme) {
        var textcolor = $('body').css("color");
        url = url + "?color=" + encodeURI(textcolor);
      }
      mail.find("iframe").attr('src',  url);
    }

    if (info.tags) {
      var mailTags = template('mailtags', info);
      $(document).find('.mail-tags').html(mailTags);
    } else 
      $(document).find('.mail-tags').html("");

    if (info.mailInfo.hasOwnProperty('signRed')) {
      var sign = info.mailInfo['signRed'];
      var flag = mail.find('.mail-info-summary .flag-icon,.mail-info-all .flag-icon');
      sign ? flag.attr('id', "flag".concat(sign)) : flag.attr('id', 'flag');
    }
  },
  // 替換邮件信息
  replaceMailInfo: function replaceMailInfo(info) {
    // 把邮件标题信息进行解码
    var decodeInfoTitle = escape(info.title);
    $('.mail-conversations .title').attr("data-id", info.mailInfo[0].mailId);
    $('.mail-conversations .title').text(decodeInfoTitle);

    ifShowWaterMark(info);

    if (api.supportTheme) {
      var textcolor = $('body').css("color");
      info.mailInfo.forEach(function (mail) {
        if (mail.content) {
            mail.content = mail.content + "?color=" + encodeURI(textcolor);
        }
      });
    }

    if (info.tags) {
      var mailTags = template('mailtags', info);
      $(document).find('.mail-tags').html(mailTags);
    } else 
      $(document).find('.mail-tags').html("");

    $('.mail-conversations .mail-box').remove();
    mailRender.renderConversations(info.mailInfo);

    if (typeof Promise.resolve === 'function') {
      Promise.resolve(api.clearReadMailTemplate(false));
    } else {
      setTimeout(function () {
        api.clearReadMailTemplate(false);
      });
    }
  },
  // 更新邮件加密状态信息
  updateMailEncrptInfo: function updateMailEncrptInfo(info) {
    var mailInfo = mailRender.getMailInfoByMailId(info.mailId);
    var mail = getMailByMailId(info.mailId);

    if (info.attachment) {
      info.attachment.map(function (item) {
        item['_suffix'] = String(item.name.split('.')[item.name.split('.').length - 1]).toUpperCase();
      });
    }

    mailInfo['attachment'] = info.attachment ? info.attachment : '';
    mailInfo['content'] = info.content ? escape(info.content) : '';
    mailInfo['encryptInfo']['bEncrypted'] = info.bEncrypted;
    var newInfo = template('mail-conversation', mailInfo);
    mail.html(newInfo);
    bindAttachmentMenuEvent();
  },
  // 更新阅后即焚邮件信息
  updateMailAutoDeleteInfo: function updateMailAutoDeleteInfo(info) {
    var mailId = info.mailId;
    var mail = getMailByMailId(mailId);
    var markup = mail.find('.auto-destroy');
    var newInfo = template('autoDestroyMail', info);
    markup.html(newInfo);
  },
  // 更新邮件日程（会议）信息
  updateMailCalendarInfo: function updateMailCalendarInfo(info) {
    var mailId = info.mailId;
    var mail = getMailByMailId(mailId);
    var markup = mail.find('.calendar');
    var newInfo = template('calendarMail', info);
    markup.html(newInfo);
  },
  // 更新邮件内容的字体大小
  zoomLevel: function zoomLevel(args) {
    var mailId = args['mailId'];
    var iframe = document.getElementById("iframe_".concat(mailId));
    if (!iframe) return;
    var backupLevel = window.zoomLevel;
    window.zoomLevel = args['level'] / 100;
    $(iframe.contentWindow).scrollLeft(0);
    $(iframe.contentDocument.documentElement).css('zoom', 'none');
    $(iframe.contentDocument.documentElement).css('zoom', window.zoomLevel);
    var rate = (window.zoomLevel / backupLevel).toFixed(2);

    if ($(iframe).attr('src') !== '') {
      if (rate >= 1 && window.zoomLevel >= 1) {
        var newHeight = $(iframe).contents().height();
        $(iframe).height(newHeight);
      } else if (rate < 1 && window.zoomLevel >= 0.75) {
        var height = $(iframe).contents().height() * rate;
        $(iframe).height(height);
      }
    }

    whetherShowScrollInside($('iframe').attr('id'));
  },
  // 选中所有同类型的用户
  selectAllUser: function selectAllUser(users) {
    var currentMail = getMailByMailId(users['mailId']);
    var selection = window.getSelection();
    var range = document.createRange();
    var node = currentMail.find("#user_".concat(users['userType']))[0];
    range.selectNode(node);
    selection.removeAllRanges();
    selection.addRange(range);
  },
  // 选中所有附件
  selectAllAttachment: function selectAllAttachment(mail) {
    var mail = getMailByMailId(mail.mailId);
    mail.find('.mail-attachments .attachment-item').each(function () {
      $(this).addClass('attachment-item-selected');
    });
  },
  // 选择邮件正文
  selectMailContent: function selectMailContent(mail) {
    var currentIframe = document.getElementById("iframe_".concat(mail['mailId']));
    var mailId = currentIframe.id.split('_')[1];
    var params = {
      appSelectMailContent: true,
      mailId: mailId
    };
    currentIframe.contentWindow.postMessage(JSON.stringify(params), '*');
  },
  // 全选，如当前选中在收件人的区域，则选中收件人区域，否则，选中邮件正文内容
  selectAll: function selectAll(mailId) {
    var selection = window.getSelection();
    var detailDom = document.getElementsByClassName('dropdown-detail')[0];
    var otherLiDom = document.getElementsByClassName('otherLi');
    var firstLiDom = document.getElementsByClassName('firstLi')[0];
    var lastLiDom = document.getElementsByClassName('lastLi')[0];

    for (var i = 0; i < otherLiDom.length; i++) {
      if (selection.containsNode(otherLiDom[i], true)) {
        selectLetterHeaderDetail();
      }
    }

    if (selection.containsNode(firstLiDom, true) || selection.containsNode(lastLiDom, true)) {
      selectLetterHeaderDetail();
    } else {
      var iframeDom = document.getElementsByTagName('iframe')[0];
      iframeDom.focus();
      selectMailContent();
    }
  },

  /**
  * 设置发件人头像
  * @param {Object} { mailId: '', url: ''}
  * eg: 调用格式app.setAvatar({mailId: '', url: ''})
  */
  setAvatar: function setAvatar() {
    var avatorObj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var mailId = avatorObj.mailId,
        _avatorObj$url = avatorObj.url,
        url = _avatorObj$url === undefined ? '' : _avatorObj$url;
        // var avator = document.querySelector('.operation-left .sender-avator')

    var dropdown = document.querySelector('.no-dropdown-detail');
    var avator = document.querySelector('#avator_' + formatMailId(mailId));
    if (!avator) return;
    if (url) {
      dropdown.classList.add('no-dropdown-detail-flex');
      avator.style.display = 'block';
      avator.setAttribute('src', url);
    } else {
      dropdown.classList.remove('no-dropdown-detail-flex');
      avator.style.display = 'none';
      var defaultSrc = './static/img/man.png';
      avator.setAttribute('src', defaultSrc);
    }
  },

  /**
  * 清空读信内容
  * @param {boolean} clear: true -> 清空， false -> 不清空
  */
  clearReadMailTemplate: function clearReadMailTemplate() {
    var clear = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
    var mailContainer = document.querySelector('.main-container');
    var fullWhitePage = document.querySelector('.fullWhitePage');
    if (!fullWhitePage && clear) {
      fullWhitePage = document.createElement('div');
    }
    if (clear) {
      fullWhitePage.classList.add('fullWhitePage');
      mailContainer.appendChild(fullWhitePage);
      document.querySelector('#mailConversations').style.display = 'none';
    } else {
      !!fullWhitePage && mailContainer.removeChild(fullWhitePage);
      document.querySelector('#mailConversations').style.display = 'block';
    }
  },

  /**
   * 获取已被鼠标点击选择的附件
   */
  getSelectedAttach: function getSelectedAttach() {
    var mailId = $('.mail-attachments .attachment-item').parents('.mail-box').data('mailid');
    var resultArrs = {
      mailId: mailId,
      fileId: [] // 单击选中的附件存放数组
    };
    var mail = getMailByMailId(mailId);
    var selectedAttachments = mail.find('.mail-attachments .attachment-item-selected');
    selectedAttachments.each(function (index, file) {
      var fileid = file.dataset.fileid.toString();
      resultArrs.fileId.push(fileid);
    });
    callPC('attachmentSelected', resultArrs);
  },
  /**
    * 高亮关键字
    * @param {Object} keywords 
    *  all 全部搜索
    *  content 正文
    *  subject 邮件主题（标题）
    *  sender 发件人
    *  receiver 收件人
    */
  hightLightKeyWords: function hightLightKeyWords() {
    var keywords = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var isFirst = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var hasHightEle = false; // 用于确认 iframe里面的关键字是否为首次出现false为是，true为不是

    var attachMark, mailDetailMark, titleMark, dropdownDetailMark;
    var all = keywords.all,
        content = keywords.content,
        subject = keywords.subject,
        sender = keywords.sender,
        receiver = keywords.receiver;
    var iframe = document.getElementsByTagName('iframe')[0];
    var mailId = iframe.id.split('_')[1];
    var titleDom = document.querySelector('.title-box');
    var senderDom = document.querySelector('.firstLi');
    var receiverDom = document.querySelector('.otherLi');
    var attachDom = document.querySelector('.mail-attachments');
    var mailDetailDom = document.querySelector('.mail-details');
    var dropdownDetailDom = document.querySelector('.dropdown-detail');
    var senderDom2 = document.querySelector('.operation-left');
    var receiverDom2 = document.querySelector('.detail-summary');

    if (all && all.length !== 0) {
      $('.title-box').highlight(all, {
        className: 'hightLight-body',
        element: 'mark'
      });
      $('.mail-attachments').highlight(all, {
        className: 'hightLight-body',
        element: 'mark'
      });
      $('.mail-details').highlight(all, {
        className: 'hightLight-body',
        element: 'mark'
      });
      titleMark = titleDom.querySelector('.hightLight-body');
      mailDetailMark = mailDetailDom.querySelector('.hightLight-body');
      if (attachDom) attachMark = attachDom.querySelector('.hightLight-body');
      if (titleMark || mailDetailMark || attachMark) hasHightEle = true;

      if (attachMark) {
        $('.attachment-name').css('width', '138px');
      }

      var param = {
        mailId: mailId,
        keywords: all,
        hightLight: true,
        hasHightEle: hasHightEle
      };
      iframe.contentWindow.postMessage(JSON.stringify(param), '*');
    } else {
      if (subject && subject.length !== 0) {
        $('.title-box').highlight(subject, {
          className: 'hightLight-body',
          element: 'mark'
        });
        var titleMark = titleDom.querySelector('.hightLight-body');
        if (titleMark) hasHightEle = true;
      }

      if (sender && sender.length !== 0) {
        $('.firstLi').highlight(sender, {
          className: 'hightLight-body',
          element: 'mark'
        });
        $('.operation-left').highlight(sender, {
          className: 'hightLight-body',
          element: 'mark'
        });
        senderMark = senderDom.querySelector('.hightLight-body');
        senderMark2 = senderDom2.querySelector('.hightLight-body');

        if (senderMark && !hasHightEle || senderMark2 && !hasHightEle) {
          hasHightEle = true;
        }
      }

      if (receiver && receiver.length !== 0) {
        $('.otherLi').highlight(receiver, {
          className: 'hightLight-body',
          element: 'mark'
        });
        $('.detail-summary').highlight(receiver, {
          className: 'hightLight-body',
          element: 'mark'
        });
        receiverMark = receiverDom.querySelector('.hightLight-body');
        receiverMark2 = receiverDom2.querySelector('.hightLight-body');

        if (receiverMark && !hasHightEle || receiverMark2 && !hasHightEle) {
          if (receiverMark2) {
            scrollFirstHightLight(receiverDom2);
          }

          hasHightEle = true;
        }
      }

      if (content && content.length !== 0) {
        $('.mail-attachments').highlight(content, {
          className: 'hightLight-body',
          element: 'mark'
        });
        if (attachDom) attachMark = attachDom.querySelector('.hightLight-body');

        if (attachMark) {
          hasHightEle = true;
          var attachItem = attachDom.querySelectorAll('.attachment-name');
          attachItem.forEach(function (ele) {
            scrollFirstHightLight(ele);
          });
          $('.attachment-name').addClass('attachment-mark');
        }

        var param = {
          mailId: mailId,
          keywords: content,
          hightLight: true,
          hasHightEle: hasHightEle
        };
        iframe.contentWindow.postMessage(JSON.stringify(param), '*');
      }
    } 
    // 判断下拉详情内是否高亮，高亮则要展开
    dropdownDetailMark = dropdownDetailDom.querySelector('.hightLight-body');
    if (dropdownDetailMark) {
      expandOrFoldDetail(1);
    };
  }
};