"use strict";

// 获取指定mailid的一封会话邮件
function getMailByMailId(mailId) {
  return $('div.mail-box[data-mailid="' + mailId + '"]');
} // 获取特定fileid的一个附件


function getFileByFileId(fileId) {
  return $('div.attachment-item[data-fileid="' + fileId + '"]');
} // 转换邮件正文路径


function escape(string) {
  string = string || '';
  return string.replace(/&nbsp;/g, ' ').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&apos;/g, '"').replace(/&quot;/g, "'").replace(/&amp;/g, '&').replace(/&#162;/g, '￠').replace(/&pound;/g, '£').replace(/&yen;/g, '¥').replace(/&euro;/g, '€').replace(/&divide;/g, '÷').replace(/&times;/g, '×').replace(/&#34;/g, '"').replace(/&#39;/g, "'").replace(/\<br\>/g, '\n');
} // 右键单击选中邮件账户


function selectUser(user) {
  var selection = window.getSelection();
  var range = document.createRange();
  var node = user;
  range.selectNode(node);
  selection.addRange(range);
} // 选择信头详情信息


function selectLetterHeaderDetail() {
  var letterInfo = document.querySelector('.dropdown-detail');
  var selection = window.getSelection();
  var range = document.createRange();
  range.selectNode(letterInfo);
  selection.removeAllRanges();
  selection.addRange(range);
} // 全选邮件正文内容


function selectMailContent() {
  var iframeId = document.getElementsByTagName('iframe')[0];
  var ifCon = iframeId.contentWindow;
  var mailId = iframeId.id.split('_')[1];
  var params = {
    selectMailContent: true,
    mailId: mailId
  };
  ifCon.postMessage(JSON.stringify(params), '*');
  ifCon.focus();
} // 获取user格式化信息


function userInfoFormat(str) {
  var arr = [];
  var s = '"';
  var strArr = str.replace(/\s+/g, '').split(';');

  for (var i = 0; i < strArr.length - 1; i++) {
    if (strArr[i][0] == s && strArr[i][1] != "<" && strArr[i][strArr[i].length - 1] == ">") {
      arr.push(strArr[i]);
    }
  }

  return arr;
} // 获取user有效的光标信息


function getEffectiveUserInfo(str) {
  var strFormat = userInfoFormat(str);
  var objArr = [];
  var reg = /\"(.*?)\"/;

  for (var i = 0; i < strFormat.length; i++) {
    var name = strFormat[i].match(/\"(.*?)\"/g).map(function (str) {
      return str.substr(1, str.length - 2);
    }).toString();
    var email = strFormat[i].match(/\<(.*?)\>/g).map(function (str) {
      return str.substr(1, str.length - 2);
    }).toString();
    objArr.push({
      'name': name,
      'email': email
    });
  }

  return objArr;
} // 点击其他区域，之前的的光标区域取消


function cancleSelectionRect() {
  var selection = window.getSelection();
  selection.removeAllRanges();
} // 清除当前邮件的附件选中状态


function removeSelectedAttachments(mailId) {
  var mail = getMailByMailId(mailId);
  mail.find('.mail-attachments .attachment-item-selected').removeClass('attachment-item-selected');
} // 清除document所有附件的选中状态


function removeAllSelectedAttachments() {
  $(document).find('.mail-attachments .attachment-item-selected').removeClass('attachment-item-selected');
} // 清除所有document的选中状态


function removeAllSelectedDocument() {
  var selection = document.getSelection();
  selection.removeAllRanges();
} // 清除所有iframe的选中状态


function removeAllSelectedIframe() {
  var iframeId = document.getElementsByTagName("iframe")[0];
  var iframe = iframeId.contentWindow;
  var mailId = iframeId.id.split('_')[1];
  var params = {
    removeAllRanges: true,
    mailId: mailId
  };
  iframe.postMessage(JSON.stringify(params), '*');
} // iframe加载完成事件

function iframeLoaded(iframeId) {
	callPC('readMailHadLoaded', { readMailIframeLoaded: 1} );
	setIframeHeight(iframeId);
}

function setIframeHeight(iframeId) {
  var currentIframe = document.getElementById(iframeId);
  $(currentIframe).css('min-height', 613 + 'px');
  var mailId = currentIframe.id.split('_')[1];
  var titleBox = $('.title-box').height();
  var mailDetail = $('.mail-details').height();
  var iframeMinHeight = window.innerHeight - titleBox - mailDetail - 70;
  $(currentIframe).css('min-height', iframeMinHeight + 'px');
  window.addEventListener('message', function (e) {
    var data = JSON.parse(e.data);
    if (data.mailId !== mailId) return;

    if (!data.recalCulate) {
      $(currentIframe).height((data.height + 40) * window.zoomLevel);
      whetherShowScrollInside(iframeId);
    }
  }, false);
  bindMailContentMenuEvent(iframeId); //邮件正文右键事件

  bindMailContentClickEvent(iframeId); // 邮件正文点击事件
} // 根据iframe内容宽度决定是否显示内部的水平滚动条


function whetherShowScrollInside(iframeId) {
  var currentIframe = document.getElementById(iframeId);
  var mailId = currentIframe.id.split('_')[1];
  var iframeContent = $(currentIframe).parent();
  var iframeScrollWidth,
    iframeWidth = document.querySelector('.mail-content').offsetWidth;

  if (currentIframe.contentWindow) {
    var params = {
      mailId: mailId,
      recalculateWidthAndHeight: true
    };
    currentIframe.contentWindow.postMessage(JSON.stringify(params), '*');
  }

  window.onmessage = function (e) {
    var data = JSON.parse(e.data);
    if (mailId !== data.mailId) return;

    if (data.scrollWidth) {
      iframeScrollWidth = data.scrollWidth;
    }

    if (data.keydown) {
      callPC('keydown', { 
        "code" : data.keyCode
       });
       return;
     }

    if (iframeScrollWidth > iframeWidth) {
      iframeContent.find('#scroll-inside').show();
      iframeContent.find('#scroll-inside').css('position', 'fixed');
    } else {
      iframeContent.find('#scroll-inside').hide();
    }
  };
} // 格式化日程邮件状�


function formatCalendarStatus(status) {
  var statusTxt = '';

  switch (status) {
    case 1:
      statusTxt = '本次会议已取消';
      break;

    case 2:
      statusTxt = '已接受本次会议邀请';
      break;

    case 3:
      statusTxt = '已暂时接受本次会议邀请';
      break;

    case 4:
      statusTxt = '已谢绝本次会议邀请';
      break;

    case 5:
      statusTxt = '本次会议已更新';
      break;

    default:
      statusTxt = status;
      break;
  }

  return statusTxt;
} // 响应用户打开详情行为习惯


function expandOrFoldDetail(status) {
  if (status) {
    $(document).find('.dropdown-detail').show();
    $(document).find('.no-dropdown-detail .detail-button').text('隐藏信息');
  } else {
    $(document).find('.dropdown-detail').hide();
    $(document).find('.no-dropdown-detail .detail-button').text('详细信息');
  }
} // 附件总数是否显示（单封邮件）


function whetherShowAttachmentSum() {
  var totalAttachment = $(document).find('.mail-attachments').data('sum');
  var totalWidth = $(document).find('.mail-attachments').width();
  var expireItem = $('.mail-attachments').find('.expire').length;
  var itemWidth = 265;
  if (expireItem > 0) itemWidth = 435;
  var computeNumber = ~~(totalWidth / itemWidth) * 3;

  if (computeNumber >= totalAttachment) {
    $(document).find('.mail-attachments-sum .fold-sum').hide();
  } else {
    $(document).find('.mail-attachments-sum .fold-sum').show();
  }
} // iframe 高度适应缩放倍数


function iframeAutoHeight() {
  mailRender.mailInfoGroup.forEach(function (mail) {
    var iframeId = "iframe_".concat(mail.mailId);
    var currentIframe = document.getElementById(iframeId);
    var mailId = currentIframe.id.split('_')[1];

    if ($(currentIframe).attr('src') !== '') {
      var params = {
        iframeAutoHeight: true,
        mailId: mailId
      };
      currentIframe.contentWindow.postMessage(JSON.stringify(params), '*');
    }
  });
} // 判断右键点击哪部�


function rightClick() {
  $(document).contextmenu(function (e) {
    var target = e.target;

    if ($(target).closest('dropdown-detail')) {
      selectLetterHeaderDetail();
    } else {
      var iframeDom = document.getElementsByTagName('iframe')[0];
      iframeDom.focus();
      selectMailContent();
    }
  });
} // 删除水印


function removeWaterMark() {
  localStorage.removeItem('text');
  localStorage.removeItem('textDate');
  var wrapDom = document.querySelector('.watermark-wrap');
  wrapDom && wrapDom.parentNode.removeChild(wrapDom);

  if (wrapDom) {
    for (var i = 0; i <= wrapDom.length - 1; i++) {
      wrapDom.parentNode.removeChild(wrapDom[i]);
    }
  }
} // 插入水印


function insertWaterMark(str) {
  if (str) {
    var lineStr = str.split('<br>');
    var text = '',
      textDate = '';
    text = escape(lineStr[0]);

    if (lineStr[1]) {
      textDate = lineStr[1];
    }

    var body = document.body;
    localStorage.setItem('text', text);
    localStorage.setItem('textDate', textDate);
    watermark(body, text, textDate);
  }
} // 生成水印


function watermark($el, textParam, textDateParam, cvWidth, cvHeight) {
  var cv = document.querySelector('.v-watermark');
  cv && cv.parentNode.removeChild(cv);
  var canvas = document.createElement('canvas');
  canvas.classList.add('v-watermark');
  var ctx = canvas.getContext('2d');
  var titleH = document.querySelector('.title-box').clientHeight;
  titleH = titleH > 70 ? 70 : titleH;
  var bodyH = document.body.scrollHeight;
  var canvasW = window.innerWidth > 5000 ? window.innerWidth : 5000;
  var canvasH = window.innerHeight;
  var docScrollH = $el.scrollHeight > window.innerHeight ? $el.scrollHeight : window.innerHeight;
  cvHeight ? canvasH = cvHeight : '';
  cvWidth ? canvasW = cvWidth : '';
  canvas.width = canvasW;
  canvas.height = 2000;
  var date = ''; // 日期

  var text = ''; // 文本

  textDateParam ? date = textDateParam : '';
  textParam ? text = textParam : '';
  var textLength = ctx.measureText(text).width;
  var intervalWidth = 234; // 每行的文字的宽度距离

  var customHeight = 180; // 每行的高度距�

  var angle = -12; // 度数

  var site = angle * Math.PI / 180;
  var secondTextlineHeight = 20; // 第二行文字的行高

  var rows = parseInt(canvas.height / customHeight);
  var colums = parseInt(canvas.width / (textLength + intervalWidth));
  ctx.save();
  ctx.font = '17px 微软雅黑';
  ctx.textAlign = 'center';
  ctx.fillStyle = api.isDarkMode ?  "#ffffff" : "#000000";
  ctx.globalAlpha = 0.2;
  ctx.rotate(site);

  for (var i = 1; i <= rows + 1; i++) {
    for (var j = 0; j <= colums; j++) {
      // 偶数�
      if (i % 2 === 0) {
        ctx.fillText(text, j * (textLength + intervalWidth) + textLength, i * customHeight);
        ctx.fillText(date, j * (textLength + intervalWidth) + textLength, i * customHeight + secondTextlineHeight);
      } else {
        ctx.fillText(text, j * (textLength + intervalWidth), i * customHeight);
        ctx.fillText(date, j * (textLength + intervalWidth), i * customHeight + secondTextlineHeight);
      }
    }
  }

  ctx.restore();
  var base64Url = canvas.toDataURL();
  var wrapDom = document.querySelector('.watermark-wrap');

  if (!wrapDom) {
    wrapDom = document.createElement('div');
  }

  wrapDom.setAttribute('style', "\n      position: fixed;\n      width: 100%;\n      z-index: 9;\n      top: 0;\n      height: 100%;\n      left: 30px;\n      pointer-events: none;\n      background-repeat:repeat;\n      background-image:url('".concat(base64Url, "')"));
  wrapDom.classList.add('watermark-wrap');
  $el.style.position = 'relative';
  $el.insertBefore(wrapDom, $el.firstChild);
} // 自适应宽高


function resizeCanvas() { } // 水平滚动条滚动事件


function moveScrollBarInside(e, mid) {
  e.preventDefault();
  var mail = getMailByMailId(mid);
  var iframe = document.getElementById("iframe_".concat(mid));
  var x = e.pageX - $(e.target).offset().left; //滑块左侧到当前鼠标的距离[内部距离]

  var width = $(e.target).parent().width() - $(e.target).width();
  $(document).bind("mousemove", function (e) {
    var rectX = e.pageX - x - mail.find(".scroll-wrap").offset().left; //确保滑块不会超出滑轨的范围

    if (rectX < 0) {
      rectX = 0;
    } else if (rectX >= width) {
      rectX = width;
    } // iframeX 是 iframe内容移动的距离，按比例计算


    mail.find(".scroll-rect").css("left", rectX);
    var params = {
      rectX: rectX,
      width: width,
      mailId: mid
    };
    iframe.contentWindow.postMessage(JSON.stringify(params), '*');
  }); // 取消绑定mousemove事件

  $(document).mouseup(function () {
    $(document).unbind("mousemove");
  });
  iframe.contentWindow.postMessage(JSON.stringify({
    cancelMouseMove: true,
    mailId: mid
  }), '*');
} // 鼠标离开水平滚动条 取消mousemove事件


function listenerHandle() {
  window.addEventListener('message', function (e) {
    var data = JSON.parse(e.data);

    if (data.iframeCallCancelMouseMove) {
      $(document).unbind("mousemove");
    }
  }, true);
}

// 是否调用水印接口
function ifShowWaterMark(mail) {
  if (mail.waterMark) {
    removeWaterMark();
    if (typeof Promise.resolve === 'function') {
      Promise.resolve(insertWaterMark(mail.waterMark));
    } else {
      setTimeout(function () {
        insertWaterMark(mail.waterMark);
      });
    }
  } else {
    removeWaterMark();
  }
}

/**
 * 转义选择器冒号
 * @param {String} mailId 
 */
function formatMailId(mailId) {
  var index = mailId.indexOf(':');
  if (index !== -1) {
    return mailId.substring(0, index) + '\\\:' + mailId.substring(index + 1);
  } else {
    return mailId;
  }
}