
// 初始化单击事件代理
function clickHandlerInit() {
  var d = $(document);
  d.click(function (e) {
    if (!$(e.target).hasClass('attachment-item') || !$(e.target).parent().hasClass('attachment-item')) {
      removeAllSelectedAttachments();
    }
  }); //绑定点击事件的代理

  d.on('click', '[_click]', function (e) {
    if (!$(e.target).hasClass('attachment-item') || !$(e.target).parent().hasClass('attachment-item')) {
      removeAllSelectedAttachments();
    }

    var event = $(e.currentTarget).attr('_click').split('('); // console.log(event)
    // 点击信头区域，iframe区域的光标取消

    bindLetterHeaderClickHandler(e);
    var func = event[0],
        param = event[1] ? event[1].slice(0, -1) : '',
        // parameters type
    args = param.split(',').map(function (item) {
      var _item = item.trim();

      try {
        _item = eval(_item);
      } catch (err) {
        console.log(err);
      }

      return _item;
    });
    clickEventMap[func].apply($(e.currentTarget), [e].concat(args));
  });
} // 监听附件Ctrl单击选择和双击下载


function bindAttachmentMenuEvent() {
  $('.mail-attachments .attachment-item').each(function () {
    var mailId = $(this).parents('.mail-box').data('mailid');
    var mail = getMailByMailId(mailId); // 存在过期附件时增大附件容器的外边距

    var expireItemNum = mail.find('.mail-attachments .expire').length;

    if (expireItemNum > 0) {
      mail.find('.mail-attachments .attachment-item').css('margin-right', '185px');
    }

    $(this).click(function (e) {
      e.stopPropagation();

      if (e.ctrlKey === true) {
        $(this).addClass('attachment-item-selected');
      } else {
        removeSelectedAttachments(mailId);
      }

      $(this).addClass('attachment-item-selected');
    });
    $(this).mousedown(function (e) {
      // 附件拖拽下载
      e.stopPropagation();
      var currentAttachment = this;
      var moveX = e.pageX,
          moveY = e.pageY;
      $(this).mousemove(function (e) {
        if (e.pageX !== moveX || e.pageY !== moveY) {
          var params = {
            mailId: mailId,
            fileId: []
          };
          var selectedAttachments = mail.find('.mail-attachments .attachment-item-selected');
          var endFileId = $(this).data('fileid').toString();
          selectedAttachments.each(function () {
            var fileId = $(this).data('fileid').toString();
            if (fileId !== endFileId) params['fileId'].push(fileId);
          });
          params['fileId'].push(endFileId);
          callPC('attachmentStartDrag', params);
          $(this).unbind('mousemove');
        }
      });
      $(document).mouseup(function () {
        $(currentAttachment).unbind("mousemove");
      });
    });
    $(this).dblclick(function (e) {
      var fileId = $(this).data('fileid').toString();
      var params = {
        mailId: mailId,
        fileId: fileId
      };
      callPC('attachmentDownload', params);
    });
  });
} // 监听邮件正文右键菜单


function bindMailContentMenuEvent(iframeId) {
  var iframe = document.getElementById(iframeId);
  $(iframe.contentWindow).mousedown(function (e) {
    removeAllSelectedAttachments();
    removeAllSelectedDocument();
  });
} // 监听邮件正文点击事件


function bindMailContentClickEvent(iframeId) {
  var iframe = document.getElementById(iframeId);
  $(iframe.contentWindow).mousedown(function (e) {
    removeAllSelectedAttachments();
    removeAllSelectedDocument();
  });
} // 监听信头点击事件


function bindLetterHeaderClickHandler(e) {
  e.stopPropagation();
  e.preventDefault();
  $(document).mousedown(function () {
    removeAllSelectedIframe();
  });
} // 窗口大小改变事件


function windowResized(e) {
  whetherShowAttachmentSum(); // 控制附件总数是否显示（单封邮件）

  // iframeAutoHeight(); // 控制iframe高度适应缩放倍数

  // whetherShowScrollInside($('iframe').attr('id'));
}

function moveScrollBarInside(e, mid) {
  e.preventDefault();
  var mail = getMailByMailId(mid);
  var iframe = document.getElementById("iframe_".concat(mid));
  var x = e.pageX - $(e.target).offset().left; //滑块左侧到当前鼠标的距离[内部距离]

  var width = $(e.target).parent().width() - $(e.target).width();
  $(document).bind("mousemove", function (e) {
    var rectX = e.pageX - x - mail.find(".scroll-wrap").offset().left; //确保滑块不会超出滑轨的范围

    if (rectX < 0) {
      rectX = 0;
    } else if (rectX >= width) {
      rectX = width;
    } //iframeX是iframe内容移动的距离，按比例计算


    var iframeX = rectX * ($(iframe).contents().width() - $(iframe.contentWindow).width()) / width;
    mail.find(".scroll-rect").css("left", rectX);
    $(iframe.contentWindow).scrollLeft(iframeX);
  });
  $(document).mouseup(function () {
    $(document).unbind("mousemove");
  });
  $(iframe.contentWindow).mouseup(function () {
    $(document).unbind("mousemove");
  });
}

var clickEventMap = {
  // 显示账号信息
  showUserInfo: function showUserInfo(e) {
    e.stopPropagation();
    var target = e.target;
    var user = {
      name: '',
      email: ''
    };

    if (target.className === 'user') {
      user.email = String($(target).attr('title'));
      user.name = String($(target).data('name'));
      callPC('userDetail', user);
    } else if ($(target).parent().hasClass('user')) {
      user.email = String($(target).parent().attr('title'));
      user.name = String($(target).parent().data('name'));
      callPC('userDetail', user);
    }
  },
  // 展开会话邮件
  expandMailContent: function expandMailContent(e) {
    e.stopPropagation();
    var mailId = this.parents('.mail-box').data('mailid');
    var currentMail = getMailByMailId(mailId);
    $(this).hide();
    currentMail.fadeIn();
    currentMail.find('.mail-info-all').show();
  },
  // 折叠会话邮件
  foldMailContent: function foldMailContent(e) {
    e.stopPropagation(); // var mailId = this.parents('.mail-box').data('mailid')
    // var currentMail = getMailByMailId(mailId)
    // currentMail.find('.mail-info-all').hide()
    // currentMail.fadeIn()
    // currentMail.find('.mail-info-summary').css('display', 'flex')
  },
  // 显示或隐藏详细信息
  showOrHideDetail: function showOrHideDetail(e) {
    e.stopPropagation();
    var mailId = this.parents('.mail-box').data('mailid');
    var currentMail = getMailByMailId(mailId);
    var currentDetail = currentMail.find('.dropdown-detail');

    if (currentDetail.css('display') === 'none') {
      $(this).text('隐藏信息');
      currentDetail.slideDown(300);
      callPC('showMailDetail', {
        showDetail: true
      });
    } else {
      $(this).text('详细信息');
      currentDetail.slideUp(300);
      callPC('showMailDetail', {
        showDetail: false
      });
    }
  },
  // 显示更多操作
  showMoreOperation: function showMoreOperation(e) {
    e.stopPropagation();
    var mailId = this.parents('.mail-box').data('mailid');
    callPC('showDropDown', mailId);
  },
  // 改变红旗标记状态
  changeFlagStatus: function changeFlagStatus(e) {
    e.stopPropagation();
    var mailId = this.parents('.mail-box').data('mailid');

    if ($(this).attr('id') !== 'flag') {
      callPC('signAsRed', {
        mailId: mailId,
        bSign: false
      });
    } else {
      callPC('signAsRed', {
        mailId: mailId,
        bSign: true
      });
    }
  },
  // 显示更多附件
  showMoreAttachments: function showMoreAttachments(e, sum) {
    e.stopPropagation();
    var mailId = this.parents('.mail-box').data('mailid');
    var currentMail = getMailByMailId(mailId);
    var currentAttachments = currentMail.find('.mail-attachments');

    if (currentAttachments.css('max-height') !== 'none') {
      currentAttachments.css('max-height', 'none');
      $(this).find('.fold-icon').addClass('fold-icon-expand');
      $(this).find('.sum-text').text('收起');
    } else {
      currentAttachments.css('max-height', '120px');
      $(this).find('.fold-icon').removeClass('fold-icon-expand');
      $(this).find('.sum-text').text("\u5171".concat(sum, "\u4E2A\u9644\u4EF6"));
    }
  },
  // 更新自动销毁邮件
  refreshAutoDeleteInfo: function refreshAutoDeleteInfo(e, mailId) {
    e.stopPropagation();
    var params = {
      mailId: mailId
    };
    callPC('refreshAutoDeleteInfo', params);
  },
  // 接受日程邀请
  acceptCalendar: function acceptCalendar(e, mailId) {
    e.stopPropagation();
    callPC('calendarMailAction', {
      mailId: mailId,
      action: 1
    });
  },
  // 待定日程邀请
  waitCalendar: function waitCalendar(e, mailId) {
    e.stopPropagation();
    callPC('calendarMailAction', {
      mailId: mailId,
      action: 2
    });
  },
  // 谢绝日程邀请
  rejectCalendar: function rejectCalendar(e, mailId) {
    e.stopPropagation();
    callPC('calendarMailAction', {
      mailId: mailId,
      action: 3
    });
  },
  // 加入我的日程
  addToCalendar: function addToCalendar(e, mailId) {
    e.stopPropagation();
    callPC('calendarMailAction', {
      mailId: mailId,
      action: 4
    });
  },
  // 使用密码解密
  decodeWithPassword: function decodeWithPassword(e, mailId) {
    e.stopPropagation();
    var mail = getMailByMailId(mailId);
    var password = mail.find('#password')[0].value;
    var params = {
      mailId: mailId,
      password: password
    };
    callPC('DecryptMail', params);
  },
  // 无需密码解密
  decode: function decode(e, mailId) {
    e.stopPropagation();
    var params = {
      mailId: mailId,
      password: ''
    };
    callPC('DecryptMail', params);
  },
  // 打开审核原邮件
  viewAuditMail: function viewAuditMail(e, mailId) {
    e.stopPropagation();
    var params = {
      mailId: mailId
    };
    callPC('viewMailAndAudit', params);
  },
  // 审核通过
  auditPass: function auditPass(e, mailId) {
    e.stopPropagation();
    var params = {
      mailId: mailId,
      bCanSend: true
    };
    callPC('auditMail', params);
  },
  // 审核拒绝
  auditReject: function auditReject(e, mailId) {
    e.stopPropagation();
    var params = {
      mailId: mailId,
      bCanSend: false
    };
    callPC('auditMail', params);
  }
};