"use strict";

window.onload = function () {

  checkTheme();

  var mailId = document.body.dataset.mail_id;
  jQuery(function ($) {
    $('.cmxreadmailcontent').autolink();
  });
  addPostMessage();

  document.addEventListener('mouseup', function (e) {
    var params = {
      mailId: mailId,
      iframeCallCancelMouseMove: true
    };
    window.parent.postMessage(JSON.stringify(params), '*');
  });

  document.addEventListener('keydown', function (e) {
    var params = {
      mailId: mailId,
      keydown: true,
      keyCode : e.key,
    };
    window.parent.postMessage(JSON.stringify(params), '*');
  });
  /**
   * 响应事件
   */

  window.onmessage = function (e) {
    var data = JSON.parse(e.data);

    //更换主题
    if (data.setTheme) {
      console.log("Set Color : " + data.color);
      setFontColor(data.color, true);
      return;
    }
    //繁简体转换
    if (data.zhtrans) {
      zh_tran(data.zh_choose);
    }
    
    if (data.mailId.toString() !== mailId) return;

    if (data.removeAllRanges === true) {
      var selection = window.getSelection();
      selection.removeAllRanges();
    }

    if (data.rectX) {
      //var iframeX = data.rectX * (document.body.scrollWidth - window.innerWidth) / data.width;
      var _scrollWidth = Math.max(document.body.scrollWidth, document.documentElement.scrollWidth);
      var iframeX = data.rectX * (_scrollWidth - window.innerWidth) / data.width
      window.scroll(iframeX, 0);
    }

    if (data.appSelectMailContent) {
      var node = document.body;
      var selection = window.getSelection();
      var range = document.createRange();
      range.selectNode(node);
      selection.removeAllRanges();
      selection.addRange(range);
    }

    if (data.selectMailContent) {
      var node = document.body;
      var documentSelect = document.getSelection();
      documentSelect.removeAllRanges();
      document.documentElement.focus();
      var range = document.createRange();
      var selection = document.getSelection();
      range.selectNode(node);
      selection.removeAllRanges();
      selection.addRange(range);
    }

    if (data.bindMailContentMenuEvent) {
      window.addEventListener('mousedown', function (e) {
        var params = {
          mailId: mailId,
          iframeMouseDown: true
        };
        window.parent.postMessage(JSON.stringify(params), '*');
      });
    }

    if (data.focus) {
      document.body.focus();
    }

    if (data.cancelMouseMove) {
      document.removeEventListener('mousemove', listenerMouseMove(), true);
    }
    /**
     * 自适应宽高
     */

    if (data.iframeAutoHeight) {
      var newHeight = document.body.offsetHeight;
      window.outerHeight = newHeight;
      window.offsetHeight = newHeight;
    }
    /**
     * 重新计算宽高
     */

    if (data.recalculateWidthAndHeight) {
      var params = getParams();
      params['recalCulate'] = true;
      window.parent.postMessage(JSON.stringify(params), '*');
    }

    //高亮关键字
    if (data.hightLight) {
      var keywords = data.keywords;
      var hasHightEle = data.hasHightEle;
      $(document.body).highlight(keywords, {
        className: 'hightLight',
        element: 'mark',
        bgColor: '#FFED00'
      });
      if (!hasHightEle) scrollFirstHightLight();
    }
  };

  // 滚动到第一个高亮词的位置
  function scrollFirstHightLight() {
    try {
      var firstElem = document.querySelector('.hightLight');
      setTimeout(function () {
        firstElem && firstElem.scrollIntoView({
          block: 'center',
          inline: 'center'
        });
      }, 60);
    } catch (err) {
      console.log(err);
    }
  }

  function addPostMessage() {
    var params = getParams();
    window.parent.postMessage(JSON.stringify(params), "*");
    console.log('postMessage start ---->');
  }
  /**
   * 获取document的宽、高、滚动宽度、mailId
   */
  function getParams() {
    var iframeClientHeight = document.body.offsetHeight;
    var iframeScrollWidth = document.body.scrollWidth;
    var iframeClientWidth = document.body.offsetWidth;
    var params = {
      height: iframeClientHeight,
      width: iframeClientWidth,
      scrollWidth: iframeScrollWidth,
      mailId: mailId
    };
    return params;
  }

  function listenerMouseMove() {
    window.addEventListener('mousemove', function () { }, true);
  }

  function parseUrlQuery() {
    var url = location.href;
    if (~url.indexOf('?'))
      url = url.split('?')[1];
    var params = url.split('&');
    var query = {};
    for (var i = 0;i < params.length; ++i) {
      var param = params[i].split('=');
      query[param[0]] = decodeURI(param[1]);
    }
    return query;
  }

  function checkTheme() {
    var query = parseUrlQuery();
    if (query.color)
      setFontColor(query.color, false);
  }

  function setFontColor(c, force) {
    $("html").css("color", c);
    $("*").each(function(){
      if (force || $(this).css('color') == 'rgb(0, 0, 0)')
        $(this).css('color', c);
    });
  }
};