"use strict";

var mailRender = {
  mailInfoGroup: [],
  getMailInfoByMailId: function getMailInfoByMailId(mailId) {
    var mailInfo = this.mailInfoGroup.find(function (item) {
      return item.mailId === mailId;
    });
    return mailInfo;
  },
  renderConversations: function renderConversations() {
    var _this = this;

    var mailInfo = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    if (mailInfo[0].calendarReceiver && mailInfo[0].calendarReceiver.location) {
      mailInfo[0].calendarReceiver.location = escape(mailInfo[0].calendarReceiver.location);
    }

    this.mailInfoGroup = mailInfo;
    mailInfo.forEach(function (mail) {
      _this.renderStandardMail(mail);

      expandOrFoldDetail(mail['showDetail']);
    });
    bindAttachmentMenuEvent();
    windowResized();
  },
  // 渲染标准邮件模板
  renderStandardMail: function renderStandardMail(mailData) {
    var mailId = mailData.mailId;
    var mail = $("<div />", {
      "class": "mail-box"
    });
    mail.attr('data-mailid', mailId);
    if (mailData.wstoneEncrypt) $(document).find('.wstone-encrypt-icon').css('display', 'inline-block');

    if (mailData.attachment) {
      mailData.attachment.map(function (item) {
        item['_suffix'] = String(item.name.split('.')[item.name.split('.').length - 1]).toUpperCase();
      });
    }

    if (mailData.content) {
      mailData.content = escape(mailData.content);
    }

    var mailContent = template('mail-conversation', mailData);
    mail.html(mailContent);
    $('#mailConversations').append(mail);
  }
};